#include <stdio.h>
#include <math.h>
#define n1 4096
#define n2 4032
#define bok  48.
#define  n 20000      // test.co3 file
char head[72][80];
float gain,see,cali,cal[4];
double a8[8],b8[8],pi,cx,cy;
int  z0[n],z1[n],nz; float xx[n],yy[n],z2[n]; long long z3[n]; char z4[n];
unsigned char bad[n2][n1];
float map[n2][n1];
int idate,ccdno,nstar;
// 2013,10,10,  add 130911_data's nbad_9?.fit 

main(int ac,char **av)
{
  int i,j,k,ip;
  float x1,x2,x3,x4;
  char f1[30],f2[30],f3[30],c[80];
  FILE *fp;
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  if(ac<2){
    printf("\n\t******** 3key (15 points higher background) *********\n");
    printf("\n\t  pipeline2: workout single p*.cat\n");
    printf("\n\t  Usage: 3key p*.fit                        20131010\n\n");
    exit(0);
  }
  system("cp /vega2/rhbin/bok.par .");
  system("cp /vega2/rhbin/headcatp.par .");
  system("cp /vega2/rhbin/uefault.param default.param");
  system("cp /vega2/rhbin/uefault.conv default.conv");
  system("cp /vega2/rhbin/uefault.nnw default.nnw");
  for(ip=1;ip<ac;ip++){
    strcpy(f1,av[ip]);
    k=nindex(f1,"."); if(k>0)f1[k]=0;         // f1=p*
    strcpy(f2,f1); strcat(f2,".fit");         // f2=p*.fit
    printf("%3d: %s\n",ip,f2);
    strcpy(f3,f1); strcat(f3,".cat");         // f3=p*.cat
    fp=fopen(f2,"rb"); if(!fp){ printf("\tfile not found: %s\n",f2); continue; }
    fread(head,72,80,fp); fread(map,n1*n2,4,fp); fclose(fp);
    sscanf(&head[3][20],"%d",&i); sscanf(&head[4][20],"%d",&j);
    if(i!=n1 || j!=n2){printf("\tnot a 4096*4032 pixel file\n"); continue; }
    k=indexpos(head,"CALIA73 ",72);
    if(k==72){ printf("\t not a cali_A73  file: %s\n",f2); continue; }
    k=indexpos(head,"SEEING  ",72); 
    if(k==72){ printf("\tI cannot find seeing in file: %s\n",f2); continue; }
    sscanf(&head[k][15],"%f",&see);
    k=indexpos(head,"CALIA73 ",72); 
    if(k==72){ printf("\tI cannot find CALIA73 in file: %s\n",f2); continue; }
    sscanf(&head[k][15],"%f",&cali);
    for(i=0;i<4;i++)if(head[k+i+1][28]!=32)sscanf(&head[k+i+1][15],"%f",&cal[i]);
                    else cal[i]=cali;
    sexjob(1.4);                             // SEX_parmater file modify
    nbad_lines(f1);                          // --> test.fit nbad_lines adjust
    system("sex test.fit");
    usltocoo(f1);                            // --> test.co2, p*.usl
    chbercoo(f1);                            // --> test.coo (co2+cat)
    system("u_phot4k test.fit");             // --> test.ap
    aptouap(f1);                             // --> p*.uap
    makecat(f1);                             // uap+ sex+ co3  ---> p*.cat
  }
  if(ac>3)system("rm test.*");
  printf("\n\t****** OK ! ********\n");
}

makecat(char *f1)
{
  int i,j,k;
  char f2[30],a[200],b[180],c1[14],c2[14];
  FILE *fp,*fp1,*fp4,*fpp;
  double x4,y5,ra,dec;
  float sky6,a737,a738;
  float b1,b2,b3,b4,b5,b6,b7,b8,b9,b10; int b11;
  int s0; float s1,s2; long long s3; char s4;
  int slima=0, slimb=0, slimc=0;
  float cali4;
// uap 191; usl 213; sex 87; co3 58
  fp=fopen("test.co3","r"); nz=0;
l01:
  fgets(b,180,fp); if(feof(fp))goto l02;
  sscanf(b,"%d %d %f %f %f %lld %c",
  &z0[nz],&z1[nz],&xx[nz],&yy[nz],&z2[nz],&z3[nz],&z4[nz]);
  if(nz<n-1)nz++; 
  goto l01;
l02:
  fclose(fp);
  fp1=fopen("test.sex","rb");
  sprintf(f2,"%s.cat",f1);
  fp4=fopen(f2,"w");
  puthead(fp4);
  sprintf(f2,"%s.uap",f1);
  fp=fopen(f2,"r");
l10:
  fgets(a,200,fp); if(feof(fp))goto l20;
  if(a[0]=='#')goto l10;
  sscanf(a,"%d %lf %lf %f",&k,&x4,&y5,&sky6);
  if(x4<15. || x4>n1-15.){ slima++; goto l10; } 
  if(y5<15. || y5>n2-15.){ slima++; goto l10; } 
  sscanf(&a[127],"%f %f",&a737,&a738);
  if(k>80000 && a737>90.){ slimb++; goto l10; }
  xy_rad(a8[6],a8[7],x4,y5,&ra,&dec,2,0);
  toms2(ra,c1,1); toms2(dec,c2,0);
// add p*.uap
  sprintf(b,"%5d%s %s %7.2lf%8.2lf %7.2f %6.3f%6.3f",k,c1,c2,x4,y5,sky6,a737,a738); 
// add test.sex
  b1=b2=b3=b4=b5=b6=b7=b8=b9=b10=0.; b11=0;
  if(k<80000){
    j=(k-1)*88; fseek(fp1,j,0); fread(a,1,88,fp1); a[89]=0;
    sscanf(&a[22],"%f%f%f%f%f%f%f%f%f%f%d",
    &b1,&b2,&b3,&b4,&b5,&b6,&b7,&b8,&b9,&b10,&b11);
  if(x4< 2048 && y5>=2016)cali4=cal[0];
  if(x4< 2048 && y5< 2016)cali4=cal[1];
  if(x4>=2048 && y5>=2016)cali4=cal[2];
  if(x4>=2048 && y5< 2016)cali4=cal[3];
    if(b2<90.)b2+=cali4; if(b4<90.)b4+=cali4;
  }
  sprintf(&b[68],"%8.2f%7.3f%6.3f%7.3f%6.3f%6.2f%5.2f%7.2f%5.2f%6.1f%3d",
    b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11);
// add sl
  s0=0; s1=s2=0.; s3=0; s4=32; 
  for(i=0;i<nz;i++)if(z0[i]==k){
    s0=z1[i]; s2=z2[i]; s3=z3[i]; s4=z4[i]; j=i;
    break;
  }
  if(k<80000 && s0!=0)s1=sqrt((x4-xx[j])*(x4-xx[j])+(y5-yy[j])*(y5-yy[j]))*0.454;
  if(s0==0){  // look sl around
    sprintf(a,"sla73 %s %s $",c1,c2);
    fpp=popen(a,"r"); fgets(a,200,fpp); pclose(fpp);
    sscanf(&a[61],"%d",&j);
    if(j){ sscanf(&a[66],"%f",&s2); if(s2==0.)s2=j*0.001; } else s2=0.;
// in area, existed usl, but un_matched, & best_mag> 20.0, then delete
    if((s2!=0. && b2 >20.) || b2>90.){ slimc++; goto l10; }
  }  
  sprintf(&b[134],"%6d%5.2f%7.3f%20lld%2c",s0,s1,s2,s3,s4);

// write
  fprintf(fp4,"%s\n",b);
  goto l10; 
l20:
  fclose(fp); fclose(fp1);
  fprintf(fp4,"#A. edge 15_pixel            %9d\n",slima);
  fprintf(fp4,"#B. num>80000 && no a73      %9d\n",slimb);
  fprintf(fp4,"#C. un_match_usl & best>20.0 %9d\n",slimc);
  fprintf(fp4,"#at last, left objects       %9d\n",nstar-slima-slimb-slimc);
  printf("#at last, left objects%9d\n",nstar-slima-slimb-slimc);       
  fclose(fp4);
}  

puthead(FILE *fp4)
{
  FILE *fp;
  int  i,j,k,ip=0;
  char f2[60],a[160];

  strcpy(f2,"test.num");
  fp=fopen(f2,"r"); if(fp==0){ printf("%s not found!\n",f2); exit(0); }
  fgets(f2,60,fp); fclose(fp);
  k=strlen(f2)-1; f2[k]=0;
  head[6][65]=head[6][78]=0;

  fp=fopen("headcatp.par","r");
  if(!fp){ printf(" Cannot found headcatp.par!\n"); exit(0); }
l10:
  fgets(a,160,fp); if(feof(fp))goto l20;
  if(a[0]<=32)goto l10;
  if(a[0]=='#'){
    if(a[1]!=32 || a[2]!='1')fputs(a,fp4);
    else {
      k=strlen(a); while(a[k]<=32)k--; a[k+1]=0;
      fprintf(fp4,"%s %s ==> %d\n",a,f2,nstar);
    }
    goto l10;
  }
  for(i=0;i<72;i++){
    for(j=0;j<strlen(a)-1;j++)if(head[i][j]!=a[j])goto l15;
    fputc('#',fp4); fwrite(&head[i][0],1,32,fp4);
    fprintf(fp4,"\n"); ip++;
    if(ip==8){                               // put RA,DEC real center
      fprintf(fp4,"#RA      =%s  / single ccd real center\n",&head[6][45]);
      fprintf(fp4,"#DEC     =       %s   / epoch(2000.0)\n",&head[6][66]);
    } 
    goto l10;
l15:;
  }
  goto l10;
l20:
  fclose(fp);
}

nbad_lines(char *f1)
{
  int i,j,k, ib,it,il,ir;
  char a[80]; FILE *fp;
  swap4(map,n1*n2*4);
  k=indexpos(head,"CCD_NO: ",72);
  sscanf(&head[k][25],"%d",&ccdno);
  k=indexpos(head,"DATE-OBS",72);
  sscanf(&head[k][11],"%d",&k);
  idate=2; if(k==2010)idate=0; if(k==2011)idate=1;
//20131010
  sscanf(f1[1],"%d",&i);
  if(i==6546) idate=9;                     // for 130911 data, 12 line blank

  fp=fopen("/vega2/rhbin/ubandlines.dat","r");
  j=ccdno; if(idate)j+=5;
  for(i=0;i<=j;i++)fgets(a,80,fp); fclose(fp);
  sscanf(a,"%d %d %d %d",&ib,&it,&il,&ir);
  printf("ib,it,il,ir: %d %d %d %d\n",ib,it,il,ir);
  sprintf(a,"/vega2/rhbin/nbad_%d%d.fit",idate,ccdno);
  fp=fopen(a,"rb"); if(!fp){ printf("%s not found!\n",a); exit(0); }
  fread(bad,36,80,fp); fread(bad,n1,n2,fp); fclose(fp);
  for(j=0;j<n2;j++)for(i=0;i<n1;i++)if(bad[j][i])map[j][i]=0;
  for(j=0;j<ib;j++)for(i=0;i<n1;i++)map[j][i]=0;
  for(j=n2-1;j>=n2-it;j--)for(i=0;i<n1;i++)map[j][i]=0;
  for(i=0;i<il;i++)for(j=0;j<n2;j++)map[j][i]=0;
  for(i=n1-1;i>=n1-ir;i--)for(j=0;j<n2;j++)map[j][i]=0;
  if(idate==0 && ccdno==4){
    for(j=0;j<n2;j++)for(i=0;i<n1;i++)if(i<n1/2 || j>=n2/2)map[j][i]=0;
  }
  fp=fopen("test.fit","wb"); fwrite(head,72,80,fp);
  swap4(map,n1*n2*4); fwrite(map,n1*n2,4,fp); fclose(fp);
}

sexjob(double x)
{
  int k; FILE *fp,*fp1; char c[80];
  fp =fopen("/vega2/rhbin/uefault.sex","r");
  fp1=fopen("default.sex","w");
  k=(x-1.)*10+.5; k+=48;
l10:
  fgets(c,80,fp); if(feof(fp))goto l20;
// set DETECT_MINAREA	20 ===> DETECT_MINAREA	15       20120210
  if(c[0]=='D'&&c[6]=='_'&&c[7]=='M'){c[15]='1'; c[16]='5'; }
  if(c[0]=='D'&&c[6]=='_'&&c[8]=='H')c[16]=k;
  if(c[0]=='G'&&c[1]=='A'&&c[2]=='I'){sprintf(&c[6],"%4.1f",gain); c[10]=9;}
  if(c[0]=='S'&&c[1]=='E'&&c[2]=='E'){sprintf(&c[12],"%5.2f",see); c[17]=9;}
  fputs(c,fp1); goto l10;
l20:
  fclose(fp1); fclose(fp);
}

aptouap(char *f1)
{
  int i,j,k,d[12];
  char f2[30],f3[30],a[180],b[220];
  FILE *fp2,*fp3;
  float x,y,s1,s2,s3,s[12],t[12],cali4;

  strcpy(f3,f1); strcat(f3,".uap");
  fp2=fopen("test.ap","r"); if(fp2==0){ printf("%s not found!\n"); exit(0); }
  fp3=fopen(f3,"w");
  for(i=0;i<3;i++)fgets(a,180,fp2);
  j=0;
l20:
  fgets(a,180,fp2); if(feof(fp2))goto l30;
  fgets(a,180,fp2); fgets(b,220,fp2);
  sscanf(a,"%d%f%f%f%f%f%f%f%f%f%f%f%f%f%f",&k,&x,&y,
  &t[0],&t[1],&t[2],&t[3],&t[4],&t[5],&t[6],&t[7],&t[8],&t[9],&t[10],&t[11]);
  sscanf(b,"%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f",&s1,&s2,&s3,
  &s[0],&s[1],&s[2],&s[3],&s[4],&s[5],&s[6],&s[7],&s[8],&s[9],&s[10],&s[11]);
// if(a73 not existed, goto l20;
//  if(t[7]>25.)goto l20;
  if(x< 2048 && y>=2016)cali4=cal[0];
  if(x< 2048 && y< 2016)cali4=cal[1];
  if(x>=2048 && y>=2016)cali4=cal[2];
  if(x>=2048 && y< 2016)cali4=cal[3];
  for(i=0;i<12;i++)if(t[i]<90.)t[i]+=cali4;
  for(i=0;i<12;i++)if(s[i]>9.999)s[i]=9.999;
  if(s2>99.99)s2=99.99;
  fprintf(fp3,"%5d%8.2f%8.2f%8.2f%6.2f",k,x,y,s1,s2);
  for(i=0;i<12;i++)fprintf(fp3,"%7.3f%6.3f",t[i],s[i]);
  fprintf(fp3,"\n"); j++;
  goto l20;
l30:
  fclose(fp3);
  printf("after to p*.uap  %d left\n",j);
  nstar=j;
  sprintf(a,"sort -n --key=3,4 %s > test.tmp",f3); system(a);

  fp2=fopen("bok.par","r");
  if(fp2==0){ printf("bok.par not found!\n"); exit(0); }
  for(i=0;i<20;i++)fgets(a,180,fp2);
l10:
  fgets(a,180,fp2); if(a[0]!='*')goto l10;
  i=0;
l11:
  fgets(a,180,fp2);
  sscanf(&a[32],"%f",&x);
  d[i++]=x+0.1;
  if(i!=12)goto l11;
  fclose(fp2);
  fp3=fopen(f3,"w"); 
  fprintf(fp3,"# 1 number        i5    ( 'Bertin_Sex' workout )\n");
  fprintf(fp3,"# 2 Ber_x         f8.2  (pixles)    \n");
  fprintf(fp3,"# 3 Ber_y         f8.2  (pixles)    \n");
  fprintf(fp3,"# 4 DAO_phot_sky  f8.2  (adu/pixel) \n");
  fprintf(fp3,"# 5 sky_err       f6.2  (adu)\n");
  for(i=0;i<12;i++){
    fprintf(fp3,"#%2d photo_mag     f7.3 ( RADIUS OF APERTURE %2d )\n",i*2+6,d[i]);
    fprintf(fp3,"#%2d mag_err       f6.3 (mag)\n",i*2+7);
  }
  fprintf(fp3,"#\n");
  fp2=fopen("test.tmp","r");
  for(i=0;i<j;i++){ fgets(b,220,fp2); fputs(b,fp3); }
  fclose(fp2); fclose(fp3);
}

usltocoo(char *f1)  
{
  int i,j,k;
  char f2[60],f3[60],f4[60],b[200];
  double dx,dy,alpha,delta;
  float dz;
  FILE *fp3,*fp4;
  strcpy(f2,f1); strcat(f2,".fit");
  strcpy(f4,f1); strcat(f4,".usl");
  fp4=fopen(f2,"rb"); fread(head,72,80,fp4); fclose(fp4);
  k=indexpos(head,"A81     ",72);
  if(k==72){ printf("%s not coordinating!\n",f2); exit(0); }
  for(i=0;i<8;i++)sscanf(&head[k+i][10],"%lf",&a8[i]);
  xytoad(a8,b8);
  k=indexpos(head,"DEC-OBS ",72);     head[k][78]=0;
  sprintf(b,"dr973r %s 31 %s 23.0 !",&head[k][53],f4);       // 20130318
  system(b);

  fp4=fopen(f4,"r");
  fp3=fopen("test.co2","w"); 
l10:
  fgets(b,220,fp4); if(feof(fp4))goto l20;
  if(b[0]=='#')goto l10;
  sscanf(b,"%d",&k);
  b[18]=b[31]=b[51]=0;
  chs(&b[6],&alpha,1); chs(&b[19],&delta,0);
  rad_xy(a8[6],a8[7],alpha,delta,&dx,&dy,2,0);
//  printf("%s %s %lf %lf  %lf %lf\n",b,&b[19], alpha,delta, dx,dy);
  if(dx < 10. || dy < 10.)goto l10;
  if(dx>n1-10 || dy>n2-10)goto l10;
  if(idate==0 && ccdno==4)if(dx<2048 || dy>2032)goto l10;
//  sscanf(&b[52],"%f",&dz);
  sscanf(&b[118],"%f",&dz);             //   20130318 r_psf
  fprintf(fp3,"%5d %8.3lf %8.3lf %6.3f %s %c\n",k,dx,dy,dz,&b[32],b[78]);
  goto l10; 
l20:
  fclose(fp3); fclose(fp4);
}

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

toms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%6.3f",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}

xy_rad(ac,dc,x,y,ra,de,type,k)
double ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);
    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}

rad_xy(ac,dc,ra,de,x,y,type,k)
double ac,dc,ra,de,*x,*y;  int type,k;
{
  double xi,xn, tmp,rar,der;
  rar=ra*cx; der=de*cy;
  tmp=atan(tan(der)/cos(rar-ac));
  xi=cos(tmp)*tan(rar-ac)/cos(tmp-dc);
  xn=tan(tmp-dc);
  if(type==1){     // schmidt TELESCOPE
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=atan(tmp)/tmp;
      xi*=tmp; xn*=tmp;
    }
  }
  if(type==2){    //  BOK telescope
    tmp=1.+bok*(xi*xi+xn*xn);
    xi*=tmp; xn*=tmp;
  }
  if(k==0){
    *x=b8[0]*xi+b8[2]*xn+b8[4];
    *y=b8[1]*xi+b8[3]*xn+b8[5];
  }
  if(k==1){ *x=xi; *y=xn;}
}

chs(a,y)
char *a; double *y;
{
  double x;
  char b[20];
  int i,j,k;
  strcpy(b,a); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}

chbercoo(char *f1)
{
  int i,j,k;
  FILE *fp2,*fp3,*fp4;
  char a[160],f2[60],f3[60];
  float rdno,gain,x1,x2,x3,x4;
  float x24=23.;
  int j1,j2,j3,j4,m;
  float x_1,x0,x5,x6, x8,x9,x10,x11; int x7;

  fp2=fopen("test.cat","r"); if(!fp2){printf("test.cat not found!\n"); exit(0);}
  fp3=fopen("test.coo","w");
  k=indexpos(head,"RDNOCAL ",72);
  sscanf(&head[k][9],"%f %f %f %f",&x1,&x2,&x3,&x4);
  rdno=(x1+x2+x3+x4)/4;
  k=indexpos(head,"GAINCAL ",72);
  sscanf(&head[k][9],"%f %f %f %f",&x1,&x2,&x3,&x4);
  gain=(x1+x2+x3+x4)/4;
  fprintf(fp3," NL   NX   NY  LOWBAD HIGHBAD  THRESH");
  fprintf(fp3,"     AP1  PH/ADU  RNOISE    FRAD\n");
  fprintf(fp3,"  1 8640 8200     0.1 60000.0   22.76   10.00");
  fprintf(fp3,"%8.2f%8.2f    10.00\n\n",gain,rdno);
  fp4=fopen("test.sex","w");
  k=i=0;
l10:
  fgets(a,160,fp2); if(feof(fp2))goto l20;
  if(a[0]=='#')goto l10;
  sscanf(&a[47],"%f%f %f%f%f%f %f%f %d %f%f%f%f",
    &x_1,&x0, &x1,&x2,&x3,&x4, &x5,&x6, &x7, &x8,&x9,&x10,&x11);
  sscanf(a,"%d",&k); i++; xx[k]=0.;
// for *.sex only
  if(x0>0.99)x0=9.99; if(x10>9.99)x10=9.99; x7&=0x1f;
  fprintf(fp4,"%5d%8.2f%8.2f%8.2f%7.3f%6.3f%7.3f%6.3f%6.2f%5.2f%7.2f%5.2f%6.1f%3d\n",
  k,x1,x2,x3,x_1,x0,x9,x10,x11,x8,x4,x6,x5,x7);
    if(x4>99.)goto l10;                     // too big star 20120610
  if(x1<10 || x1>n1-10)goto l10;
  if(x2<10 || x2>n2-10)goto l10;
  fprintf(fp3,"%5d %9.3f %9.3f\n",k,x1,x2);
  xx[k]=x1; yy[k]=x2; 
  goto l10;
l20:
  fclose(fp2); fclose(fp4);
  j1=i;  j2=k;   j++;  m=k;   // usl begin number

  fp4=fopen("test.co3","w");
  sprintf(f2,"test.co2",f1);
  fp2=fopen(f2,"r"); if(fp2==0){ printf("%s not found!\n",f2); exit(0); }
  j3=j4=0; j=80001;
l30:
  fgets(f2,60,fp2);  if(feof(fp2))goto l40;
  sscanf(f2,"%d %f %f %f",&i,&x1,&x2,&x3);  j3++;
  if(x3>x24)goto l30;
  for(i=1;i<=k;i++){
    if(xx[i]==0.)continue;
    x3=xx[i]-x1; x4=yy[i]-x2;
    if(x3*x3+x4*x4 < 4.){
      fprintf(fp4,"%5d %s",i,f2);
      goto l30;          // 2pixel, 0.9" match
    }
  }
  fprintf(fp3,"%5d %9.3f %9.3f\n",j,x1,x2); 
  fprintf(fp4,"%5d %s",j,f2);
  j++; m++; j4++;
  goto l30;
l40:
  fclose(fp3); fclose(fp4);
  printf("all: %d(%d)+%d(%d)=%d\n",j2,j1,j4,j3,m);
  fp3=fopen("test.num","w");
  fprintf(fp3," %d(%d)+%d(%d)=%d\n",j2,j1,j4,j3,m);
  fclose(fp3);
}
